/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.client.ui;

import java.awt.*;
import java.awt.event.ItemEvent;
import java.util.Vector;
import java.applet.AppletContext;
import java.net.URL;
import java.awt.datatransfer.*;

import tstuder.java.lib.component.table.*;

import de.hendriklipka.ldse.common.ResultListener;
import de.hendriklipka.ldse.common.ResultDescriptor;
import de.hendriklipka.ldse.client.ResultTableRow;
import de.hendriklipka.ldse.client.ClientConfig;

/**
  zeigt die Ergebnisse einer Suche an
*/
public class ResultFrame extends java.awt.Frame implements ResultListener
{
	public ResultFrame(QueryFrame parent, ClientConfig config)
	{
	  // Spalten der Tabelle hinzufuegen
    _config=config;
		Vector v=new Vector(5,5);
		ColumnDefinition urlDef=new ColumnDefinition(resultFrameBundle.getString("ResultFrame_ColumnDefinition_urlDef_new_ColumnDefinition"));
		urlDef.setWidthAdjustment(ColumnDefinition.WIDTH_AUTO);
		v.addElement(urlDef);
		ColumnDefinition sizeDef=new ColumnDefinition(resultFrameBundle.getString("ResultFrame_ColumnDefinition_sizeDef_new_ColumnDefinition"));
		sizeDef.setWidthAdjustment(ColumnDefinition.WIDTH_AUTO);
		v.addElement(sizeDef);
		ColumnDefinition relDef=new ColumnDefinition(resultFrameBundle.getString("ResultFrame_ColumnDefinition_relDef_new_ColumnDefinition"));
		relDef.setWidthAdjustment(ColumnDefinition.WIDTH_AUTO);
		v.addElement(relDef);
		ColumnDefinition titDef=new ColumnDefinition(resultFrameBundle.getString("ResultFrame_ColumnDefinition_titDef_new_ColumnDefinition"));
		titDef.setWidthAdjustment(ColumnDefinition.WIDTH_AUTO);
		v.addElement(titDef);
    tableResult=new Table(v,_rows);
	  
		setLayout(new GridBagLayout());
		setVisible(false);
		tableResult.setShowLineNumbers(true);
		tableResult.setLayout(new GridLayout(1,1,0,0));
		add(tableResult,new myGridBagConstraints(0,0,1,1,2.0,2.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(2,2,2,2),0,0));
		tableResult.setForeground(java.awt.Color.black);
		tableResult.setFont(new Font("Dialog", Font.PLAIN, 12));
		tableResult.setBounds(2,2,509,152);
		setEnabled(false);
		setBackground(java.awt.Color.lightGray);
		setSize(513,383);
		panelResult.setLayout(new GridBagLayout());
		add(panelResult,new myGridBagConstraints(0,1,1,1,2.0,2.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(2,2,2,2),0,-220));
		panelResult.setBounds(2,158,509,196);
		labelTitle.setText(resultFrameBundle.getString("labelTitle_text"));
		panelResult.add(labelTitle, new myGridBagConstraints(0,0,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelTitle.setBounds(15,2,37,23);
		textFieldTitle.setEditable(false);
		textFieldTitle.setText("");
		panelResult.add(textFieldTitle, new myGridBagConstraints(1,0,3,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),0,0));
		textFieldTitle.setBounds(70,2,436,23);
		labelURL.setText(resultFrameBundle.getString("labelURL_text"));
		panelResult.add(labelURL, new myGridBagConstraints(0,1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelURL.setBounds(14,29,39,23);
		textFieldURL.setEditable(false);
		textFieldURL.setText("");
		panelResult.add(textFieldURL, new myGridBagConstraints(1,1,3,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),0,0));
		textFieldURL.setBounds(70,29,436,23);
		labelRelevance.setText(resultFrameBundle.getString("labelRelevance_text"));
		panelResult.add(labelRelevance, new myGridBagConstraints(0,2,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelRelevance.setBounds(2,56,64,23);
		textFieldLastChanged.setEditable(false);
		panelResult.add(textFieldLastChanged, new myGridBagConstraints(3,3,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),0,0));
		textFieldLastChanged.setBounds(370,83,136,23);
		textFieldRelevance.setEditable(false);
		textFieldRelevance.setText("");
		panelResult.add(textFieldRelevance, new myGridBagConstraints(1,2,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),0,0));
		textFieldRelevance.setBounds(70,56,194,23);
		labelSize.setText(resultFrameBundle.getString("labelSize_text"));
		panelResult.add(labelSize, new myGridBagConstraints(0,3,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelSize.setBounds(9,83,49,23);
		textFieldSize.setEditable(false);
		panelResult.add(textFieldSize, new myGridBagConstraints(1,3,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),0,0));
		textFieldSize.setBounds(70,83,194,23);
		labelLastChanged.setText(resultFrameBundle.getString("labelLastChanged_text"));
		panelResult.add(labelLastChanged, new myGridBagConstraints(2,3,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelLastChanged.setBounds(268,83,98,23);
		labelExcerpt.setText(resultFrameBundle.getString("labelExcerpt_text"));
		panelResult.add(labelExcerpt, new myGridBagConstraints(0,4,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(2,2,2,2),0,0));
		labelExcerpt.setBounds(7,110,54,23);
		textAreaExcerpt.setEditable(false);
		textAreaExcerpt.setText("");
		panelResult.add(textAreaExcerpt, new myGridBagConstraints(0,5,4,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(2,2,2,2),0,0));
		textAreaExcerpt.setBounds(2,137,504,57);
		panelButtons.setLayout(new GridLayout(1,2,2,2));
		add(panelButtons,new myGridBagConstraints(0,2,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,2,2,2),415,0));
		panelButtons.setBounds(2,358,509,23);
		buttonAnzeigen.setLabel(resultFrameBundle.getString("buttonAnzeigen_label"));
		panelButtons.add(buttonAnzeigen);
		buttonAnzeigen.setBounds(0,0,125,23);
		buttonHilfe.setLabel(resultFrameBundle.getString("buttonHilfe_label"));
		panelButtons.add(buttonHilfe);
		buttonHilfe.setBounds(127,0,125,23);
		// diese 2 Button erscheinen nur bei einer Applikation
		if (!config.isApplet())
		{
		  buttonCopy.setLabel(resultFrameBundle.getString("buttonCopy_label"));
		  panelButtons.add(buttonCopy);
		  buttonCopy.setBackground(java.awt.Color.lightGray);
		  buttonCopy.setBounds(254,0,125,23);
		  buttonExport.setLabel(resultFrameBundle.getString("buttonExport_label"));
		  panelButtons.add(buttonExport);
		  buttonExport.setBackground(java.awt.Color.lightGray);
		  buttonExport.setBounds(381,0,125,23);
		}
		setTitle(resultFrameBundle.getString("ResultFrame_title"));

    // Listener anmelden
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		buttonAnzeigen.addActionListener(lSymAction);
		buttonHilfe.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		tableResult.addItemListener(lSymItem);
		buttonCopy.addActionListener(lSymAction);
		buttonExport.addActionListener(lSymAction);

		_parent=parent;
		if (_config.isApplet())
		{
		  buttonExport.setEnabled(false);
		  buttonCopy.setEnabled(false);
		}
	}

	public ResultFrame(QueryFrame parent, String title, ClientConfig config)
	{
		this(parent,config);
		setTitle(title);
	}

  public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	public void addNotify()
	{
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	tstuder.java.lib.component.table.Table tableResult = null;
	java.awt.Panel panelResult = new java.awt.Panel();
	java.awt.Label labelTitle = new java.awt.Label();
	java.awt.TextField textFieldTitle = new java.awt.TextField();
	java.awt.Label labelURL = new java.awt.Label();
	java.awt.TextField textFieldURL = new java.awt.TextField();
	java.awt.Label labelRelevance = new java.awt.Label();
	java.awt.TextField textFieldLastChanged = new java.awt.TextField();
	java.awt.TextField textFieldRelevance = new java.awt.TextField();
	java.awt.Label labelSize = new java.awt.Label();
	java.awt.TextField textFieldSize = new java.awt.TextField();
	java.awt.Label labelLastChanged = new java.awt.Label();
	java.awt.Label labelExcerpt = new java.awt.Label();
	java.awt.TextArea textAreaExcerpt = new java.awt.TextArea();
	java.awt.Panel panelButtons = new java.awt.Panel();
	java.awt.Button buttonAnzeigen = new java.awt.Button();
	java.awt.Button buttonHilfe = new java.awt.Button();
	java.awt.Button buttonCopy = new java.awt.Button();
	java.awt.Button buttonExport = new java.awt.Button();

  // Ergenisse, die in der Table angezeigt werden
  protected Vector _rows=new Vector(50,50);
  protected QueryFrame _parent; // zur Benachrichtigung beim Schliessen
  protected ClientConfig _config=null;
  
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == ResultFrame.this)
				ResultFrame_WindowClosing(event);
		}
	}
	
	void ResultFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);	
		dispose();
		_parent.resultFrameClosed(this);
	}

  // Callback-Methode zum Lesen der Ergebnisse
  public void startResult()
  {
    int i=_rows.size();
    _rows.removeAllElements();
    if (i!=0)
    {
      tableResult.rowsRemoved(0,i);
    }
	  textFieldURL.setText("");
	  textFieldSize.setText("");
	  textFieldRelevance.setText("");
	  textAreaExcerpt.setText("");
	  textFieldTitle.setText("");
	  textFieldLastChanged.setText("");
  }
  
  // Callback-Methode zum Lesen der Ergebnisse
  public void addResult(ResultDescriptor rd)
  {
    TableRow tr=new ResultTableRow(rd);
    _rows.addElement(tr);
  }
  
  // Callback-Methode zum Lesen der Ergebnisse
  public void setResultNum(int num)
  {
  }
  
  // Callback-Methode zum Lesen der Ergebnisse
  public void endResult()
  {
    if (0!=_rows.size())
    {
      tableResult.rowsAdded(_rows.size());
      tableResult.adjustColumnWidths();
      try
      {
        tableResult.select(0,true);
      }
      // Exception, weil hier mit hoher Wahrscheinlichkeit der Frame noch nicht
      // sichtbar ist und deswegen die Table eine Exception wirft
      // (kein Graphics-Object)
      catch (Exception ex) {}
      // und daher loesen wir das Select per Hand aus...
  	  ResultTableRow tr=(ResultTableRow)_rows.firstElement();
  	  doSelect(tr);
    }
  }

  // Listener fuer die Buttons
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonAnzeigen)
				buttonAnzeigen_ActionPerformed(event);
			else if (object == buttonHilfe)
				buttonHilfe_ActionPerformed(event);
			else if (object == buttonCopy)
				buttonCopy_ActionPerformed(event);
			else if (object == buttonExport)
				buttonExport_ActionPerformed(event);
		}
	}

  // Anzeigen eines Dokumentes
	void buttonAnzeigen_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  try
	  {
	    String url=textFieldURL.getText();
	    // bei einem Applet nehmen wir den bereits vorhandenen Browser
	    if(_config.isApplet())
	    { 
	      _config.getContext().showDocument(new URL(url),url);
	    }
	    // bei einer Applikation oeffnen wir einen neuen
	    else
	    {
    	  Runtime.getRuntime().exec(_config.getBrowser()+" "+url);
	    }
  	}
  	catch (Exception ex) 
  	{
  	  ex.printStackTrace();
  	}
	}

	void buttonHilfe_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  ResultFrameHelp frame=new ResultFrameHelp();
	  frame.setVisible(true);
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == tableResult.getDataArea())
				tableResult_itemStateChanged(event);
		}
	}

  // wenn der User in der Table was ausgewaehlt hat
  void doSelect(ResultTableRow tr)
  {
	  ResultDescriptor rd=tr.getData();
	  textFieldURL.setText(rd.getURL());
	  textFieldSize.setText(Integer.toString(rd.getSize()));
	  textFieldRelevance.setText(Double.toString(rd.getRelevance()));
	  textAreaExcerpt.setText(rd.getExcerpt());
	  textFieldTitle.setText(rd.getTitle());
	  textFieldLastChanged.setText(rd.getLastChange().toString());
  }
  
  // wenn der User in der Table was auswaehlt
	void tableResult_itemStateChanged(ItemEvent event)
	{
	  if (event.getSource()!=tableResult.getDataArea())
	  {
	    return;
	  }
	  if (ItemEvent.SELECTED==event.getStateChange())
	  {
  	  ResultTableRow tr=(ResultTableRow)event.getItem();
	    doSelect(tr);
	  }
	  else if (ItemEvent.DESELECTED==event.getStateChange())
	  {
	    textFieldURL.setText("");
	    textFieldSize.setText("");
	    textFieldRelevance.setText("");
	    textAreaExcerpt.setText("");
	    textFieldTitle.setText("");
	    textFieldLastChanged.setText("");
	  }
	}
  
  // URL kopieren
	void buttonCopy_ActionPerformed(java.awt.event.ActionEvent event)
	{
		Clipboard cp=Toolkit.getDefaultToolkit().getSystemClipboard();	
		StringSelection ss=new StringSelection(textFieldURL.getText());
		cp.setContents(ss,ss);
	}

  // alle Daten kopieren
	void buttonExport_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  String data="Number,URL,Size,Relevance,Excert\n";
	  for (int i=0;i<_rows.size();i++)
	  {
	    ResultTableRow tr=(ResultTableRow)_rows.elementAt(i);
	    data+=(i+1)+","+tr.getData().getURL()+","+tr.getData().getSize()+","+tr.getData().getRelevance()+","+tr.getData().getExcerpt()+"\n";
	  }
		Clipboard cp=Toolkit.getDefaultToolkit().getSystemClipboard();	
		StringSelection ss=new StringSelection(data);
		cp.setContents(ss,ss);
	}
	static java.util.ResourceBundle resultFrameBundle = java.util.ResourceBundle.getBundle("de.hendriklipka.ldse.client.ui.ResultFrameBundle");
}
